> For the complete documentation index, see [llms.txt](https://docs.e6data.com/query-engine/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.e6data.com/query-engine/reference/limits-and-quotas/workspace-limits.md).

# Workspace limits

Naming rules and limits for workspaces, service accounts, and tokens in e6data.

Reference limits for workspaces and the identities scoped to them.

## Workspace naming

| Rule                   | Value                                   |
| ---------------------- | --------------------------------------- |
| Length                 | 3–18 characters                         |
| Allowed characters     | Lowercase letters, numbers, and hyphens |
| First / last character | Must be a letter or number              |

There is no hard limit on the number of workspaces in an organization. Each workspace is independently billed for compute, and access control is per-workspace.

## Service accounts

| Rule                | Value                                                                    |
| ------------------- | ------------------------------------------------------------------------ |
| Name length         | 3–63 characters                                                          |
| Name characters     | Lowercase letters, digits, hyphens; not starting or ending with a hyphen |
| Name mutability     | Permanent (cannot be renamed)                                            |
| API key name length | 1–128 characters                                                         |
| Keys per account    | No hard limit                                                            |

## Tokens

| Rule       | Value                                                       |
| ---------- | ----------------------------------------------------------- |
| Expiry     | Entered in days; default 90, maximum 3650, or never expires |
| Visibility | The secret is shown once at creation                        |

## See also

* [Cluster limits](/query-engine/reference/limits-and-quotas/cluster-limits.md)
* [Workspaces](/query-engine/guides/workspaces.md)
* [Access tokens](/query-engine/guides/security/access-tokens.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.e6data.com/query-engine/reference/limits-and-quotas/workspace-limits.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
